import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { DealerUser, DealerUserParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询分销商用户记录表
 */
export async function pageDealerUser(params: DealerUserParam) {
  const res = await request.get<ApiResult<PageResult<DealerUser>>>(
    MODULES_API_URL + '/shop/dealer-user/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询分销商用户记录表列表
 */
export async function listDealerUser(params?: DealerUserParam) {
  const res = await request.get<ApiResult<DealerUser[]>>(
    MODULES_API_URL + '/shop/dealer-user',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加分销商用户记录表
 */
export async function addDealerUser(data: DealerUser) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改分销商用户记录表
 */
export async function updateDealerUser(data: DealerUser) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-user',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除分销商用户记录表
 */
export async function removeDealerUser(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-user/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除分销商用户记录表
 */
export async function removeBatchDealerUser(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/dealer-user/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询分销商用户记录表
 */
export async function getDealerUser(id: number) {
  const res = await request.get<ApiResult<DealerUser>>(
    MODULES_API_URL + '/shop/dealer-user/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
